#!/bin/sh
# SD modes :"720x576-50i", "768x576-50i", "640x480-60i".
# HD modes :"640x480-60p", "1920x1080-50i", "1920x1080-60i", "1280x720-60p".

# As we are using mod_init=NO, be sure that EVERY DRIVERS are initialized when calling this script

invalid=0
mode1=0
webkit=0
case $# in
	"0")
		mode0=720x576-50i
		mem0=4
		format0=ARGB1555
		ratio0="4TO3"
	;;
	
	*)
		case $1 in
		"PAL")
			mode0=720x576-50i
			mem0=4
			format0=ARGB1555
			ratio0="4TO3"
			if [ $2 ] && [ $2 = "AUX" ] ; then
				mode1=720x576-50i
				mem1=4
				format1=ARGB1555
				ratio1="4TO3"
			else if [ $2 ] && [ $2 != "AUX" ] ; then
				echo "Invalid argument, Probably you were trying, source load_fb.sh PAL AUX"
				invalid=1
			fi
			fi
		;;

		"HD")
			mode0=1280x720-50
			mem0=8
			format0=ARGB8888
			ratio0="4TO3"
			if [ $2 ] && [ $2 = "AUX" ] ; then
				mode1=720x576-50i
				mem1=4
				format1=ARGB1555
				ratio1="4TO3"
			else if [ $2 ] && [ $2 != "AUX" ] ; then
				echo "Invalid argument, Probably you were trying, source load_fb.sh HD AUX"
				invalid=1
			fi
			fi
		;;
		
		"FULLHD")
			mode0=1920x1080-50i
			mem0=16
			format0=ARGB1555
			ratio0="4TO3"
			if [ $2 ] && [ $2 = "AUX" ] ; then
				mode1=720x576-50i
				mem1=4
				format1=ARGB1555
				ratio1="4TO3"
			else if [ $2 ] && [ $2 != "AUX" ] ; then
				echo "Invalid argument, Probably you were trying, source load_fb.sh FULLHD AUX"
				invalid=1
			fi
			fi
		;;

		"WEBKIT")
			case $2 in
			"PAL")
				webkit=1
				mode0=720x576-50i
				mem0=32
				aux_mem=38
				format0=ARGB1555
				ratio0="4TO3"
				if [ $3 ] && [ $3 = "AUX" ] ; then
					mode1=720x576-50i
					mem1=4
					format1=ARGB1555
					ratio1="4TO3"
				else if [ $3 ] && [ $3 != "AUX" ] ; then
					echo "Invalid argument, Probably you were trying, source load_fb.sh WEBKIT PAL AUX"
					invalid=1
				fi
				fi
			;;
			
			"HD")
				webkit=1
				mode0=720x576-50i
				mode0=1280x720-50
				mem0=64
				aux_mem=38
				format0=ARGB8888
				ratio0="16TO9"
				if [ $3 ] && [ $3 = "AUX" ] ; then
					mode1=720x576-50i
					mem1=4
					format1=ARGB1555
					ratio1="4TO3"
				else if [ $3 ] && [ $3 != "AUX" ] ; then
					echo "Invalid argument, Probably you were trying, source load_fb.sh WEBKIT HD AUX"
					invalid=1
				fi
				fi
			;;

			"FULLHD")
				webkit=1
				mode0=1920x1080-50i
				mem0=32
				aux_mem=38
				format0=ARGB8888
				ratio0="16TO9"
				if [ $3 ] && [ $3 = "AUX" ] ; then
					mode1=720x576-50i
					mem1=4
					format1=ARGB1555
					ratio1="4TO3"
				else if [ $3 ] && [ $3 != "AUX" ] ; then
					echo "Invalid argument, Probably you were trying, source load_fb.sh WEBKIT FULLHD AUX"
					invalid=1
				fi
				fi
			;;

			*)
				echo "Invalid Webkit configuration, nothing to do"
				echo "Usage:"
				echo "source load_fb.sh WEBKIT PAL <AUX>"
				echo "source load_fb.sh WEBKIT HD <AUX>"
				echo "source load_fb.sh WEBKIT FULLHD <AUX>"
				invalid=1
			;;
			esac
		;;

		*)
			echo "Invalid fb configuration, nothing to do"
			echo "Usage:"
			echo "source load_fb.sh"
			echo "source load_fb.sh PAL <AUX>"
			echo "source load_fb.sh HD <AUX>"
			echo "source load_fb.sh FULLHD <AUX>"
			echo "source load_fb.sh WEBKIT for webkit options"
			invalid=1
		;;
		esac
	;;
esac


# Insert module
# -------------
function load_stgfb
{
	case $1 in
	"GFX0")
		echo "Configuring GFX0(MAIN) with resolution=$2 mem=$3 pixelformat=$4 aspect-ratio=$5" aux_mem="$6"
		if [ $webkit = "1" ] ; then
			insmod $MODULES_INSTALL_DIR/stgfb_core.ko mod_init=NO g_devnum=1 layer_name=GFX_LAYER0 g_tvOutMode="$2" g_mem="$3" g_format="$4" g_ratio="$5" aux_mem="$6"
		else
			insmod $MODULES_INSTALL_DIR/stgfb_core.ko mod_init=NO g_devnum=1 layer_name=GFX_LAYER0 g_tvOutMode="$2" g_mem="$3" g_format="$4" g_ratio="$5"
		fi
	;;
	
	"GFX0,GFX1")
		echo "Configuring GFX0(MAIN) with resolution=$2 mem=$4 pixelformat=$6 aspect-ratio=$8" aux_mem="${10}"
		echo "Configuring GFX1(AUX)  with resolution=$3 mem=$5 pixelformat=$7 aspect-ratio=$9"
		if [ $webkit = "1" ] ; then
			insmod $MODULES_INSTALL_DIR/stgfb_core.ko mod_init=NO g_devnum=2 layer_name="GFX_LAYER0,GFX_LAYER1" g_tvOutMode="$2,$3" g_mem="$4,$5" g_format="$6,$7" g_ratio="$8,$9" aux_mem="${10}"
		else
			insmod $MODULES_INSTALL_DIR/stgfb_core.ko mod_init=NO g_devnum=2 layer_name="GFX_LAYER0,GFX_LAYER1" g_tvOutMode="$2,$3" g_mem="$4,$5" g_format="$6,$7" g_ratio="$8,$9"
		fi
	;;
	
	esac
}

if [ $invalid != "1" ] ; then
	if [ $mode1 = "0" ] ; then
		load_stgfb "GFX0" $mode0 $mem0 $format0 $ratio0 $aux_mem
	else
		load_stgfb "GFX0,GFX1" $mode0 $mode1 $mem0 $mem1 $format0 $format1 $ratio0 $ratio1 $aux_mem
	fi

	# Set path
	# --------
	export PATH=/usr/X11R6/bin:/usr/X11R7/bin:$PATH
	export LD_LIBRARY_PATH=${LD_LIBRARY_PATH}:/usr/lib:/lib:/usr/X11R6/lib:/usr/X11R7/lib
	export DISPLAY=':0.0'
	export DFBARGS="module-dir=/usr/lib/directfb-stsdk,pixelformat=ARGB,mode=1920x1080,no-sighandler"

	# Change global alpha of /dev/fbX frame buffer
	# --------------------------------------------
	if [ $webkit = "1" ] ; then
		$MODULES_INSTALL_DIR/stgfb_control /dev/fb0 a 30
		if [ $mode1 != "0" ] ; then
			$MODULES_INSTALL_DIR/stgfb_control /dev/fb1 a 30
		fi

	else
		$MODULES_INSTALL_DIR/stgfb_control /dev/fb0 a 128
		if [ $mode1 != "0" ] ; then
			$MODULES_INSTALL_DIR/stgfb_control /dev/fb1 a 128
		fi
	fi

	# Start X ?
	# -------
	#/usr/X11R6/bin/Xfbdev &
	#/usr/X11R6/bin/xloadimage -onroot -center /root/fbtest/linuxlogo.tif &
fi
